<?

/*
eveQuery: Classe para interao com banco de dados

-----------------------------------------------------

Desenvolvido por Everton da Rosa.
Licena GNU (www.gnu.org).

-----------------------------------------------------

eveQuery  uma classe PHP para interao com banco de dados.
Verso 1.3 (20 de novembro de 2007)
Banco de dados suportados: mysql
Funes: conexo, pesquisa

Futuro: suporte ao postgresql e a odbc

chageLog
20/11/2007
- Incluso de identificadores nas mensagens de erro facilitando o debug.


Para detalhes e ajuda complementar, consulte http://www.php.net/manual/pt_BR/index.php (manual em portugus do PHP)
Tpicos recomendados:
- Classes e Objetos (PHP 5): http://www.php.net/manual/pt_BR/language.oop5.php
- Variveis: http://www.php.net/manual/pt_BR/language.variables.php
- Funes do MySQL: http://www.php.net/manual/pt_BR/ref.mysql.php

Caso faa correes, melhorias ou modificaes, favor contatar o desenvolvedor atravs do e-mail everton3x@gmail.com enviando o cdigo para atualizao da classe nos sites onde ela se encontra hospedada.

Para exemplo de uso, veja o arquivo eveQuery.samples.php

Ao utilizar esta classe, por favor indique seu autor da seguinte forma:
-----------------------------------------------------
eveQuery: Classe para interao com banco de dados

Desenvolvido por Everton da Rosa (everton3x@gmail.com).
Licena GNU (www.gnu.org).
-----------------------------------------------------

Ao utilizar cdigo baseado nesta classe, por favor referencie da seguinte forma:
-----------------------------------------------------
Baseado na classe eveQuery: Classe para interao com banco de dados, desenvolvida por Everton da Rosa (everton3x@gmail.com) sob licena GNU (www.gnu.org).
-----------------------------------------------------

*/

class eveQuery{ //Classe para interao com banco de dados
	
	public $param = array( //parmetros gerais da classe
		'type' => 'mysql', //tipo de banco de dados padro
		'db' => 'doc' //banco de dados padro
	);
	
	public $padrao = array( //array com parmetros padro para a conexo com os bancos de dados
		'mysql' => array(//parmetros padro para conexo com mysql
			'server' => 'localhost', //servidor mysql
			'user' => 'root', //usurio para acesso ao servidor mysql
			'pw' => 'secret' //senha do usurio mysql
		)
	);
	
	function serverConnect($type=false,$config = false){//funo para conexo ao banco de dados
		
		if(!$type){
			$type = $this->param['type']; //banco de dados padro caso $type no seja definida na chamada  funo
		}
		
		if($type == 'mysql'){

			if(!$config){//se os parmetros de conexo no foram passados na chamada da funo, utiliza o padro
				$config = $this->padrao[$type];
			}

			$c = @mysql_connect($config['server'],$config['user'],$config['pw']) or die('No foi possvel conectar-se ao servidor MySQL .'.$config['server'].' com o usurio '.$config['user'].'!<br>'.mysql_error());//conecta ao banco de dados, seno retorna um erro
			
			return $c;
		
		}else{
			
			exit('eveQuery::serverConnect: Nenhum tipo vlido de conexo foi configurado na conexo!');//erro mostrado quando no existe banco de dados padr ($type) e no foi passado nenhum tipo de banco de dados, ou foi passado um tipo no existente na funo
		}
		
	}
	
	function query($sql,$type=false,$config=false,$db=false){//funo que executa a pesquisa no banco de dados. As variveis $type e $config e $db recebem o tipo de banco de dados (mysql, pgsql, etc e os parmetros de conexo (ver funo serverConnect) e o banco de dados da consulta
	
		if(!$sql){//testa se o parmetro $sql foi passado
			exit('eveQuery::query: No foi passado o parmetro $sql!');
		}else{
			if(!$type){
				$type = $this->param['type']; //banco de dados padro caso $type no seja definida na chamada  funo
			}
			
			if(!$config){//se os parmetros de conexo no foram passados na chamada da funo, utiliza o padro
				$config = $this->padrao[$type];
			}
			
			if(!$db){//se os parmetros de conexo no foram passados na chamada da funo, utiliza o padro
				$db = $this->param['db'];
			}
			
			$resource = $this->serverConnect($type,$config);//realiza a conexo com o banco de dados
			
			if($type == 'mysql'){//pesquisa no banco de dados
				$db_selected = @mysql_select_db($db) or die("No foi possvel selecionar o banco de dados $db!<br>".mysql_error());//seleciona o banco de dados
				
				$q = @mysql_query($sql) or die("No foi possvel executar a consulta $sql no banco de dados $db!<br>".mysql_error());//executa a pesquisa
				
				return $q;//retorna o resultado da pesquisa
				
			}else{
				exit("eveQuery::query: Nenhum tipo vlido de conexo foi configurado na pesquisa!");//erro se o tipo de banco de dados no foi encontrado na funo
			}
		}
	}
}
?>